# BMA Server Framework: core::TCPSocket Class Reference

core::TCPSocket Class Reference

`#include <TCPSocket.h>`

Inheritance diagram for core::TCPSocket:
[legend]
Collaboration diagram for core::TCPSocket:
[legend]

## Public Member Functions

| TCPSocket (EPoll &ePoll)
void | connect (IPAddress &address)
virtual void | output (std::stringstream &out)
Public Member Functions inherited from core::Socket
| Socket (EPoll &ePoll)
void | shutdown ()
void | setDescriptor (int descriptor)
| Set the descriptor for the socket.
int | getDescriptor ()
| Get the descriptor for the socket.
void | eventReceived (struct epoll_event event)
| Parse epoll event and call specified callbacks. More...
void | write (std::string data)
void | write (char *buffer, int length)
void | output (std::stringstream &out)
virtual void | onRegistered ()
| Called when the socket has finished registering with the epoll processing. More...
virtual void | onUnregistered ()
| Called when the socket has finished unregistering for the epoll processing. More...
void | enable (bool mode)
| Enable the socket to read or write based upon buffer.

## Public Attributes

IPAddress | ipAddress
Public Attributes inherited from core::Socket
class {
} | bufferSize
Public Attributes inherited from core::Object
std::string | name
std::string | tag

## Additional Inherited Members

Protected Member Functions inherited from core::Socket
void | setBufferSize (int length)
virtual void | onConnected ()
| Called when socket is open and ready to communicate. More...
virtual void | onTLSInit ()
virtual void | onDataReceived (std::string data)=0
| Called when data is received from the socket. More...
virtual void | receiveData (char *buffer, int bufferLength)
Protected Attributes inherited from core::Socket
EPoll & | ePoll
bool | shutDown = false

## Detailed Description

TCPSocket

Provides a network TCP socket.

For accessing TCP network functions use this object. The connection oriented nature of TCP provides a single client persistent connection with data error correction and a durable synchronous data connection.

## Member Function Documentation

## output()

void core::TCPSocket::output | ( | std::stringstream & | out | ) |

virtual

The output method is called by a socket session (BMASession) and will output the detail information for the client socket. When extending BMATCPSocket or BMASession you can override the method to add attributes to the list.

Reimplemented in core::TLSSession, and core::Session.

The documentation for this class was generated from the following files:

- /home/bradarant/barant/ServerCore/TCPSocket.h
- /home/bradarant/barant/ServerCore/TCPSocket.cpp